summaryrefslogtreecommitdiff
path: root/package/quagga
diff options
context:
space:
mode:
authorwbx <wbx@hydrogenium.(none)>2009-05-17 14:41:34 +0200
committerwbx <wbx@hydrogenium.(none)>2009-05-17 14:41:34 +0200
commit219a6dab8995aad9ac4860cc1a84d6f3509a03a4 (patch)
treeb9c0f3c43aebba2fcfef777592d0add39f2072f4 /package/quagga
Initial import
Diffstat (limited to 'package/quagga')
-rw-r--r--package/quagga/Config.in69
-rw-r--r--package/quagga/Makefile66
-rw-r--r--package/quagga/files/quagga.init327
-rw-r--r--package/quagga/ipkg/quagga-bgpd.control6
-rw-r--r--package/quagga/ipkg/quagga-ospf6d.control6
-rw-r--r--package/quagga/ipkg/quagga-ospfd.control6
-rw-r--r--package/quagga/ipkg/quagga-ripd.control6
-rw-r--r--package/quagga/ipkg/quagga-ripngd.control6
-rw-r--r--package/quagga/ipkg/quagga-vtysh.control6
-rw-r--r--package/quagga/ipkg/quagga.control6
-rw-r--r--package/quagga/ipkg/quagga.postinst16
11 files changed, 520 insertions, 0 deletions
diff --git a/package/quagga/Config.in b/package/quagga/Config.in
new file mode 100644
index 000000000..93ae9a2f4
--- /dev/null
+++ b/package/quagga/Config.in
@@ -0,0 +1,69 @@
+#menu "quagga............................ The Quagga Software Routing Suite"
+
+config ADK_PACKAGE_QUAGGA
+ prompt "quagga............................ The Quagga Software Routing Suite"
+ tristate
+ depends ADK_IPV6
+ default n
+ help
+ A routing software package that provides TCP/IP based routing services
+ with routing protocols support such as RIPv1, RIPv2, RIPng, OSPFv2,
+ OSPFv3, BGP-4, and BGP-4+
+
+ http://www.quagga.net/
+
+config ADK_PACKAGE_QUAGGA_BGPD
+ prompt " quagga-bgpd................... BGPv4, BGPv4+, BGPv4- routing engine"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ help
+ A BGPv4, BGPv4+, BGPv4- routing engine for use with Quagga routing
+ software.
+
+config ADK_PACKAGE_QUAGGA_OSPFD
+ prompt " quagga-ospfd.................. OSPFv2 routing engine"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ help
+ An OSPFv2 (IPv4) routing engine for use with Quagga routing software.
+
+config ADK_PACKAGE_QUAGGA_OSPF6D
+ prompt " quagga-ospf6d................. OSPFv3 routing engine"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ depends ADK_IPV6
+ help
+ An OSPFv3 (IPv6) routing engine for use with Quagga routing software.
+
+config ADK_PACKAGE_QUAGGA_RIPD
+ prompt " quagga-ripd................... RIP routing engine"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ help
+ A RIP (IPv4) routing engine for use with Quagga routing software.
+
+config ADK_PACKAGE_QUAGGA_RIPNGD
+ prompt " quagga-ripngd................. RIPNG routing engine"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ depends ADK_IPV6
+ help
+ A RIPNG (IPv6) routing engine for use with Quagga routing software.
+
+config ADK_PACKAGE_QUAGGA_VTYSH
+ prompt " quagga-vtysh.................. integrated shell for Quagga routing software"
+ tristate
+ default n
+ depends ADK_PACKAGE_QUAGGA
+ select ADK_PACKAGE_LIBREADLINE
+ select ADK_PACKAGE_LIBNCURSES
+ help
+ vtysh lets you interact with all the Quagga routing daemons
+ at once in an integrated shell.
+
+#endmenu
diff --git a/package/quagga/Makefile b/package/quagga/Makefile
new file mode 100644
index 000000000..7a037b50f
--- /dev/null
+++ b/package/quagga/Makefile
@@ -0,0 +1,66 @@
+# $Id$
+#-
+# This file is part of the OpenADK project. OpenADK is copyrighted
+# material, please see the LICENCE file in the top-level directory.
+
+include ${TOPDIR}/rules.mk
+
+PKG_NAME:= quagga
+PKG_VERSION:= 0.99.12
+PKG_RELEASE:= 1
+PKG_MD5SUM:= d2bb513f4ac113dbb300c15a0bd0a241
+MASTER_SITES:= http://www.quagga.net/download/ \
+ http://www.de.quagga.net/download/ \
+ http://www.uk.quagga.net/download/
+
+include ${TOPDIR}/mk/package.mk
+
+$(eval $(call PKG_template,QUAGGA,quagga,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+$(eval $(call PKG_template,QUAGGA_BGPD,quagga-bgpd,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+$(eval $(call PKG_template,QUAGGA_OSPFD,quagga-ospfd,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+ifeq ($(ADK_IPV6),y)
+$(eval $(call PKG_template,QUAGGA_OSPF6D,quagga-ospf6d,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+$(eval $(call PKG_template,QUAGGA_RIPNGD,quagga-ripngd,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+endif
+$(eval $(call PKG_template,QUAGGA_RIPD,quagga-ripd,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+$(eval $(call PKG_template,QUAGGA_VTYSH,quagga-vtysh,${PKG_VERSION}-${PKG_RELEASE},${ARCH}))
+
+CONFIGURE_STYLE:= gnu
+CONFIGURE_ARGS+= --localstatedir=/var/run/quagga \
+ --sysconfdir=/etc/quagga \
+ --enable-vtysh \
+ --enable-user=quagga \
+ --enable-group=quagga \
+ --enable-multipath=8
+BUILD_STYLE:= auto
+INSTALL_STYLE:= auto
+
+post-install:
+ ${INSTALL_DIR} ${IDIR_QUAGGA}/usr/{lib,sbin}
+ ${INSTALL_DIR} ${IDIR_QUAGGA}/etc/init.d/
+ ${CP} ${WRKINST}/usr/lib/libzebra.so.* ${IDIR_QUAGGA}/usr/lib/
+ ${INSTALL_BIN} ${WRKINST}/usr/sbin/zebra \
+ ${WRKINST}/usr/sbin/watchquagga ${IDIR_QUAGGA}/usr/sbin/
+ # avoid /etc being set to 0750
+ ${INSTALL_DIR} ${IDIR_QUAGGA}/etc/quagga/
+ chmod 0750 ${IDIR_QUAGGA}/etc/quagga/
+ ${INSTALL_BIN} ./files/quagga.init \
+ ${IDIR_QUAGGA}/etc/init.d/quagga
+ ${INSTALL_DIR} ${IDIR_QUAGGA}/var/run/quagga
+ ${INSTALL_DIR} ${IDIR_QUAGGA_BGPD}/usr/sbin
+ ${CP} ${WRKINST}/usr/sbin/bgpd ${IDIR_QUAGGA_BGPD}/usr/sbin/
+ ${INSTALL_DIR} ${IDIR_QUAGGA_OSPFD}/usr/{lib,sbin}
+ ${CP} ${WRKINST}/usr/lib/libospf.so.* ${IDIR_QUAGGA_OSPFD}/usr/lib/
+ ${CP} ${WRKINST}/usr/sbin/ospfd ${IDIR_QUAGGA_OSPFD}/usr/sbin/
+ifeq ($(ADK_IPV6),y)
+ ${INSTALL_DIR} ${IDIR_QUAGGA_OSPF6D}/usr/sbin
+ ${CP} ${WRKINST}/usr/sbin/ospf6d ${IDIR_QUAGGA_OSPF6D}/usr/sbin/
+ ${INSTALL_DIR} ${IDIR_QUAGGA_RIPNGD}/usr/sbin
+ ${CP} ${WRKINST}/usr/sbin/ripngd ${IDIR_QUAGGA_RIPNGD}/usr/sbin/
+endif
+ ${INSTALL_DIR} ${IDIR_QUAGGA_RIPD}/usr/sbin
+ ${CP} ${WRKINST}/usr/sbin/ripd ${IDIR_QUAGGA_RIPD}/usr/sbin/
+ ${INSTALL_DIR} ${IDIR_QUAGGA_VTYSH}/usr/bin
+ ${CP} ${WRKINST}/usr/bin/vtysh ${IDIR_QUAGGA_VTYSH}/usr/bin/
+
+include ${TOPDIR}/mk/pkg-bottom.mk
diff --git a/package/quagga/files/quagga.init b/package/quagga/files/quagga.init
new file mode 100644
index 000000000..6c40fe356
--- /dev/null
+++ b/package/quagga/files/quagga.init
@@ -0,0 +1,327 @@
+#!/bin/sh
+#FWINIT 50
+ME=$(basename $0)
+
+usage() {
+ echo "Usage: ${ME} {start|stop|restart} [daemon ...]"
+ exit 2
+}
+
+if [ -z "$1" ]
+then
+ usage
+else
+ COMMAND=$1
+fi
+shift
+ARG_DAEMONS=$*
+BINDIR=/usr/sbin
+CONFDIR=/etc/quagga
+STATEDIR=/var/run/quagga
+DAEMONS="zebra ripd ripngd ospfd ospf6d bgpd"
+DAEMON_FLAGS=-d
+WATCHQUAGGA_FLAGS="-d -z -T 60 -R"
+WATCHQUAGGA_CMD="sh $0 watchrestart"
+if [ ${COMMAND} != "watchrestart" ]
+then
+ DAEMONS="${DAEMONS} watchquagga"
+fi
+DAEMONS_STARTSEQ=${DAEMONS}
+
+reverse()
+{
+ local revlist r
+ revlist=
+ for r
+ do
+ revlist="$r $revlist"
+ done
+ echo $revlist
+}
+
+DAEMONS_STOPSEQ=$(reverse ${DAEMONS_STARTSEQ})
+
+#pidof() {
+# ps ax | awk 'match($5, "(^|/)'"$1"'$") > 0 { printf " %s", $1 }'
+#}
+
+quit() {
+ echo "${ME}: $1"
+ exit 0
+}
+
+die() {
+ echo "${ME}: $1"
+ exit 1
+}
+
+is_in() {
+ local i
+ for i in $2
+ do
+ [ "$1" = "$i" ] && return 0
+ done
+ return 1
+}
+
+select_subset() {
+ local unknown i j
+ unknown=
+ RESULT=
+ for i in $1
+ do
+ is_in $i "$2" || unknown="$unknown $i"
+ done
+ if [ -n "$unknown" ]
+ then
+ RESULT=$unknown
+ return 1
+ else
+ for j in $2
+ do
+ is_in $j "$1" && RESULT="$RESULT $j"
+ done
+ return 0
+ fi
+}
+
+# check command
+. /etc/rc.conf
+
+case ${COMMAND} in
+autostop) ;;
+autostart|start|stop|restart)
+ ;;
+watchrestart)
+ if [ -n "$ARG_DAEMONS" ]
+ then
+ echo "${ME}: watchrestart mode is only for use by watchquagga"
+ exit 2
+ fi
+ ;;
+*)
+ usage
+ ;;
+esac
+
+# select daemons to start
+
+case ${COMMAND} in
+autostart)
+ test x"${quagga:-NO}" = x"NO" && exit 0
+ exec sh $0 start
+ ;;
+start|restart|watchrestart)
+ START_DAEMONS=
+ for d in ${DAEMONS_STARTSEQ}
+ do
+ [ -x "${BINDIR}/${d}" -a -f "${CONFDIR}/${d}.conf" ] \
+ && START_DAEMONS="${START_DAEMONS}${d} "
+ done
+ WATCHQUAGGA_DAEMONS=${START_DAEMONS}
+ if is_in watchquagga "${DAEMONS_STARTSEQ}"
+ then
+ START_DAEMONS="${START_DAEMONS} watchquagga"
+ fi
+ if [ -n "${ARG_DAEMONS}" ]
+ then
+ if select_subset "${ARG_DAEMONS}" "${DAEMONS}"
+ then
+ if select_subset "${ARG_DAEMONS}" "${START_DAEMONS}"
+ then
+ START_DAEMONS=${RESULT}
+ else
+ die "these daemons are not startable:${RESULT}."
+ fi
+ else
+ die "unknown daemons:${RESULT}; choose from: ${DAEMONS}."
+ fi
+ fi
+ ;;
+esac
+
+# select daemons to stop
+
+case ${COMMAND} in
+stop|restart|watchrestart)
+ STOP_DAEMONS=${DAEMONS_STOPSEQ}
+ if [ -n "${ARG_DAEMONS}" ]
+ then
+ if select_subset "${ARG_DAEMONS}" "${STOP_DAEMONS}"
+ then
+ STOP_DAEMONS=${RESULT}
+ else
+ die "unknown daemons:${RESULT}; choose from: ${DAEMONS}."
+ fi
+ fi
+ stop_daemons=
+ for d in ${STOP_DAEMONS}
+ do
+ pidfile=${STATEDIR}/${d}.pid
+ if [ -f "${pidfile}" -o -n "$(pidof ${d})" ]
+ then
+ stop_daemons="${stop_daemons}${d} "
+ elif [ -n "${ARG_DAEMONS}" ]
+ then
+ echo "${ME}: found no ${d} process running."
+ fi
+ done
+ STOP_DAEMONS=${stop_daemons}
+ ;;
+esac
+
+# stop daemons
+
+for d in $STOP_DAEMONS
+do
+ echo -n "${ME}: Stopping ${d} ... "
+ pidfile=${STATEDIR}/${d}.pid
+ if [ -f "${pidfile}" ]
+ then
+ file_pid=$(cat ${pidfile})
+ if [ -z "${file_pid}" ]
+ then
+ echo -n "no pid file entry found ... "
+ fi
+ else
+ file_pid=
+ echo -n "no pid file found ... "
+ fi
+ proc_pid=$(pidof ${d})
+ if [ -z "${proc_pid}" ]
+ then
+ echo -n "found no ${d} process running ... "
+ else
+ count=0
+ notinpidfile=
+ for p in ${proc_pid}
+ do
+ count=$((${count}+1))
+ if kill ${p}
+ then
+ echo -n "killed ${p} ... "
+ else
+ echo -n "failed to kill ${p} ... "
+ fi
+ [ "${p}" = "${file_pid}" ] \
+ || notinpidfile="${notinpidfile} ${p}"
+ done
+ [ ${count} -le 1 ] \
+ || echo -n "WARNING: ${count} ${d} processes were found running ... "
+ for n in ${notinpidfile}
+ do
+ echo -n "WARNING: process ${n} was not in pid file ... "
+ done
+ fi
+ count=0
+ survivors=$(pidof ${d})
+ while [ -n "${survivors}" ]
+ do
+ sleep 1
+ count=$((${count}+1))
+ survivors=$(pidof ${d})
+ [ -z "${survivors}" -o ${count} -gt 5 ] && break
+ for p in ${survivors}
+ do
+ sleep 1
+ echo -n "${p} "
+ kill ${p}
+ done
+ done
+ survivors=$(pidof ${d})
+ [ -n "${survivors}" ] && \
+ if kill -KILL ${survivors}
+ then
+ echo -n "KILLed ${survivors} ... "
+ else
+ echo -n "failed to KILL ${survivors} ... "
+ fi
+ sleep 1
+ survivors=$(pidof ${d})
+ if [ -z "${survivors}" ]
+ then
+ echo -n "done."
+ if [ -f "${pidfile}" ]
+ then
+ rm -f ${pidfile} \
+ || echo -n " Failed to remove pidfile."
+ fi
+ else
+ echo -n "failed to stop ${survivors} - giving up."
+ if [ "${survivors}" != "${file_pid}" ]
+ then
+ if echo "${survivors}" > ${pidfile}
+ then
+ chown quagga:quagga ${pidfile}
+ echo -n " Wrote ${survivors} to pidfile."
+ else
+ echo -n " Failed to write ${survivors} to pidfile."
+ fi
+ fi
+ fi
+ echo
+done
+
+# start daemons
+
+if [ -n "$START_DAEMONS" ]
+then
+ [ -d ${CONFDIR} ] \
+ || quit "${ME}: no config directory ${CONFDIR} - exiting."
+ chown -R quagga:quagga ${CONFDIR}
+ [ -d ${STATEDIR} ] || mkdir -p ${STATEDIR} \
+ || die "${ME}: could not create state directory ${STATEDIR} - exiting."
+ chown -R quagga:quagga ${STATEDIR}
+
+ for d in $START_DAEMONS
+ do
+ echo -n "${ME}: Starting ${d} ... "
+ proc_pid=$(pidof ${d})
+ pidfile=${STATEDIR}/${d}.pid
+ file_pid=
+ if [ -f "${pidfile}" ]
+ then
+ file_pid=$(cat ${pidfile})
+ if [ -n "${file_pid}" ]
+ then
+ echo -n "found old pid file entry ${file_pid} ... "
+ fi
+ fi
+ if [ -n "${proc_pid}" ]
+ then
+ echo -n "found ${d} running (${proc_pid}) - skipping ${d}."
+ if [ "${proc_pid}" != "${file_pid}" ]
+ then
+ if echo "${proc_pid}" > ${pidfile}
+ then
+ chown quagga:quagga ${pidfile}
+ echo -n " Wrote ${proc_pid} to pidfile."
+ else
+ echo -n " Failed to write ${proc_pid} to pidfile."
+ fi
+ fi
+ elif rm -f "${pidfile}"
+ then
+ if [ "${d}" = "watchquagga" ]
+ then
+ $("${BINDIR}/${d}" \
+ ${WATCHQUAGGA_FLAGS} \
+ "${WATCHQUAGGA_CMD}" \
+ ${WATCHQUAGGA_DAEMONS})
+ status=$?
+ else
+ $("${BINDIR}/${d}" ${DAEMON_FLAGS})
+ status=$?
+ fi
+ if [ $status -eq 0 ]
+ then
+ echo -n "done."
+ else
+ echo -n "failed."
+ fi
+ else
+ echo -n " failed to remove pidfile."
+ fi
+ echo
+ done
+fi
diff --git a/package/quagga/ipkg/quagga-bgpd.control b/package/quagga/ipkg/quagga-bgpd.control
new file mode 100644
index 000000000..d8e9b80b2
--- /dev/null
+++ b/package/quagga/ipkg/quagga-bgpd.control
@@ -0,0 +1,6 @@
+Package: quagga-bgpd
+Priority: optional
+Section: net
+Depends: quagga
+Description: A BGPv4, BGPv4+, BGPv4- routing engine for use with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga-ospf6d.control b/package/quagga/ipkg/quagga-ospf6d.control
new file mode 100644
index 000000000..07cf20582
--- /dev/null
+++ b/package/quagga/ipkg/quagga-ospf6d.control
@@ -0,0 +1,6 @@
+Package: quagga-ospf6d
+Priority: optional
+Section: net
+Depends: quagga
+Description: An OSPFv3 routing engine for use with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga-ospfd.control b/package/quagga/ipkg/quagga-ospfd.control
new file mode 100644
index 000000000..c9fc77ce8
--- /dev/null
+++ b/package/quagga/ipkg/quagga-ospfd.control
@@ -0,0 +1,6 @@
+Package: quagga-ospfd
+Priority: optional
+Section: net
+Depends: quagga
+Description: An OSPFv2 routing engine for use with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga-ripd.control b/package/quagga/ipkg/quagga-ripd.control
new file mode 100644
index 000000000..e7ff89952
--- /dev/null
+++ b/package/quagga/ipkg/quagga-ripd.control
@@ -0,0 +1,6 @@
+Package: quagga-ripd
+Priority: optional
+Section: net
+Depends: quagga
+Description: A RIP routing engine for use with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga-ripngd.control b/package/quagga/ipkg/quagga-ripngd.control
new file mode 100644
index 000000000..f6b2804c2
--- /dev/null
+++ b/package/quagga/ipkg/quagga-ripngd.control
@@ -0,0 +1,6 @@
+Package: quagga-ripngd
+Priority: optional
+Section: net
+Depends: quagga
+Description: A RIPNG routing engine for use with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga-vtysh.control b/package/quagga/ipkg/quagga-vtysh.control
new file mode 100644
index 000000000..b26d11df3
--- /dev/null
+++ b/package/quagga/ipkg/quagga-vtysh.control
@@ -0,0 +1,6 @@
+Package: quagga-vtysh
+Priority: optional
+Section: net
+Depends: quagga, libncurses, libreadline
+Description: integrated shell for interacting with Quagga
+ routing software
diff --git a/package/quagga/ipkg/quagga.control b/package/quagga/ipkg/quagga.control
new file mode 100644
index 000000000..303f299e8
--- /dev/null
+++ b/package/quagga/ipkg/quagga.control
@@ -0,0 +1,6 @@
+Package: quagga
+Priority: optional
+Section: net
+Description: A routing software package that provides TCP/IP
+ based routing services with routing protocols support such
+ as RIPv1, RIPv2, RIPng, OSPFv2, OSPFv3, BGP-4, and BGP-4+.
diff --git a/package/quagga/ipkg/quagga.postinst b/package/quagga/ipkg/quagga.postinst
new file mode 100644
index 000000000..868d00de9
--- /dev/null
+++ b/package/quagga/ipkg/quagga.postinst
@@ -0,0 +1,16 @@
+#!/bin/sh
+. $IPKG_INSTROOT/etc/functions.sh
+
+gid=$(get_next_gid)
+add_group quagga $gid
+add_user quagga $(get_next_uid) $gid /tmp
+add_rcconf quagga quagga NO
+add_service zebrasrv 2600/tcp
+add_service zebra 2601/tcp
+add_service ripd 2602/tcp
+add_service ripngd 2603/tcp
+add_service ospfd 2604/tcp
+add_service bgpd 2605/tcp
+add_service ospf6d 2606/tcp
+add_service ospfapi 2607/tcp
+add_service isisd 2608/tcp